config/routes.rb
Rails.application.routes.draw do
  mount RailsAdmin::Engine => '/admin', as: 'rails_admin'
  root to: 'visitors#index'
  resources :projects, only: [:index, :show, :create, :update, :destroy]
  resources :tasks, only: [:index, :show, :create, :update, :destroy]
  resources :assignments, only: [:create, :update, :destroy]
  resources :memberships, only: [:create, :destroy]
  devise_for :users, controllers: { registrations: "registrations" }
  resources :users
end

app/views/layouts/_alert_dialog.html.haml
#alert-dialog.modal.fade.modal-dlg{tabindex: -1, role: "dialog", "aria-labelledby" => "alert-dialog-label", "aria-hidden" => "true"}
  .modal-dialog{role: "document"}
    .modal-content
      .modal-header
        %h5.modal-title#alert-dialog-label Alert
        %button{type: "button", class: "close", "data-dismiss" => "modal", "aria-label" => "Close"}
          %span{"aria-hidden" => "true"} &times;

      .modal-body

      .modal-footer
        %button.btn.btn-secondary.btn-sm{type: "button", "data-dismiss" => "modal"}
          %i.fa.fa-remove
          Cancel
        %button.btn.btn-danger.btn-sm{type: "button", onclick: "$('#alert-dialog').trigger('accept.bs.modal');"}
          %i.fa.fa-check
          Accept

app/views/layouts/_messages.html.haml
-# Rails flash messages styled for Bootstrap 4.0
- flash.each do |name, msg|
  - if msg.is_a?(String)
    %div{:class => "alert alert-#{name.to_s == 'notice' ? 'success' : 'danger'}", :role  => "alert"}
      %button.close{"aria-hidden" => "true", "data-dismiss" => "alert", :type => "button"} &times;
      = content_tag :div, msg, :id => "flash_#{name}"

app/views/layouts/_nav_links_for_auth.html.haml
-unless user_signed_in?
  %li.nav-item
    =link_to raw("<i class='fa fa-sign-in'></i> Sign in"), new_user_session_path, class: 'nav-link'
  %li.nav-item
    =link_to 'Sign up', new_user_registration_path, class: 'nav-link'

-else
  -if current_user.try(:admin?)
    %li.nav-item
      %a.nav-link{href: rails_admin.dashboard_path}
        %i.fa.fa-database
        Database Administration

  %li.nav-item.dropdown#navbarDropdownUserMenu
    %a.nav-link.dropdown-toggle#navbarDropdownUserMenuLink{"data-toggle" => "dropdown", "aria-expanded" => false, "aria-haspopup": "true", title: "#{current_user.name}#{' (VIP)' if current_user.vip?}#{' (Administrator)' if current_user.admin?}"}
      =image_tag current_user.avatar.url(:thumb, timestamp: false), :class => "rounded", style: "width: 32px; height: 32px; margin-top: -12px; margin-bottom: -10px;"

    .dropdown-menu.dropdown-menu-right{"aria-labelledby": "navbarDropdownUserMenuLink"}
      / =link_to user_path(current_user), class: "dropdown-item" do
      /   %i.fa.fa-user.fa-fw
      /   User Profile

      / =link_to edit_user_path(current_user), class: "dropdown-item" do
      /   %i.fa.fa-gear.fa-fw
      /   Preferences

      =link_to edit_user_registration_path, class: "dropdown-item" do
        %i.fa.fa-user
        Preferences

      / %li.divider

      =link_to destroy_user_session_path, method: 'delete', class: "dropdown-item" do
        %i.fa.fa-sign-out
        Sign out

app/views/layouts/_navigation.html.haml
%nav.navbar.navbar-expand-md.navbar-light.static-top
  %a.navbar-brand{href: "#{root_path}"}
    / =image_tag "public/images/original/missing.png", alt: "Systematic", style: "height: 100%;"
    %i.fa.fa-picture-o
    Taskscape

  %button.navbar-toggler{type: "button", "data-toggle": "collapse", "data-target": "#navbarCollapse", "aria-controls": "navbarCollapse", "aria-expanded": "false", "aria-label": "Toggle navigation"}
    %span.navbar-toggler-icon

  %div.collapse.navbar-collapse#navbarCollapse
    %ul.navbar-nav.mr-auto
      %li.nav-item.dropdown
        %a.nav-link.dropdown-toggle#navbarDropdownMenuLink{href: "#", "data-toggle": "dropdown", "aria-haspopup": "true", "aria-expanded": "false"}
          %i.fa.fa-bars
          Browse

        .dropdown-menu{"aria-labelledby": "navbarDropdownMenuLink"}
          %a.dropdown-item{href: "#{projects_path}#"}
            %i.fa.fa-sticky-note
            Projects
          %a.dropdown-item{href: "#{users_path}"}
            %i.fa.fa-users
            Users

      / %li.nav-item.active
      /   =link_to 'Home', root_path, class: 'nav-link'

      / %li.nav-item
      /   %a.nav-link.disabled{href: "#"} Disabled

    %ul.nav.navbar-nav.navbar-right
      =render 'layouts/nav_links_for_auth'

app/views/layouts/_navigation_links.html.haml
/ add navigation links to this file

app/views/layouts/application.html.haml
!!!
%html
  %head
    %title= content_for?(:title) ? yield(:title) : 'Taskscape'

    %meta{:name => "viewport", :content => "width=device-width, initial-scale=1.0"}
    %meta{:name => "description", :content => "#{content_for?(:description) ? yield(:description) : 'Taskscape'}"}

    = stylesheet_link_tag 'application', media: 'all' #, 'data-turbolinks-track' => 'reload'
    = javascript_include_tag 'application' #, 'data-turbolinks-track' => 'reload'
    = csrf_meta_tags

  %body
    %header
      = render 'layouts/navigation'

    %main{:role => "main"}
      = render 'layouts/messages'
      = yield
      = render 'layouts/alert_dialog'